function MI = SU2(x,y,hxy)
%% A normalized measure of mutual information called the symmetrical uncertainty is used, which can compensate for mutual information's bias toward features with more values and restricts is values to the range[0 1] by penalizing inputs with large entropies.

   %% x,y 2 άͬ
   %% ĿǼ xy ĻϢ
   row = length(x);
   x0=unique(x);
   y0=unique(y);
   
   xLen = length(x0);
   yLen = length(y0);
   
   % Contingence table
   CT = zeros(xLen+1, yLen+1);
   P = zeros(xLen+1, yLen+1);
   
   for k = 1:row  %% ͳ (Xi,Yj)Ƶ
       a = x(k);
       b = y(k);
       
       for i = 1:xLen
           if a == x0(i)
               break;
           end
       end
       
       for j = 1:yLen
           if b == y0(j)
               break;
           end
       end
       
       CT(i,j) = CT(i,j) + 1;
   end
   
   CT(xLen+1,:) = sum( CT(1:xLen,:) ); 
   CT(:,yLen+1) = sum( CT(:, 1:yLen), 2);
 
   P = CT/row;
   
   
   MI = 0;
   for i = 1:xLen
       for j = 1:yLen
           if P(i,j) > 0
             MI = MI + P(i,j)*log2( P(i,j)/( P(i,yLen+1) * P(xLen+1,j)) );
           end
       end
   end
   MI = 2*MI/(hxy); 
   
   
  
end